Subject: RE: TCP Checksum Interoperability

From: Michael Smith <[email-masked]>
Date: Fri, 5 Apr 2002 10:30:48 -0800

Lloyd: your comment is interesting.

I know there hasn't been much activity on tcp-impl, but it's still there.
Allison sent an email a while back encouraging it's use, but I can't find
that just now.

To subscribe (or unsubscribe) to the tcp-impl mailing list, send mail to
[email-masked] with one of the following in the body of the message.

subscribe tcp-impl 

unsubscribe tcp-impl 

There's also http://groups.yahoo.com/group/tcp-impl/ but activity there
stopped about July 2001. I never understood how the two mailing lists
related, but I posted your mail (below) to both, I hope you don't mind.

Aloha

Mike Smith
CTO, iReady

-----Original Message-----
From: Lloyd Wood [mailto:[email-masked]]
Sent: Friday, April 05, 2002 4:43 AM
To: Chris Trobridge
Cc: [email-masked]
Subject: Re: TCP Checksum Interoperability

See sections 3-5 of RFC1624 for discussion of the one's complement
problem for the IP header checksum. I presume similar applies for TCP,
although I don't know offhand if it's written down anywhere.

L.

On Fri, 5 Apr 2002, Chris Trobridge wrote:

> I writing to this list because the TCP workgroup was shutdown a while ago.
>
> We have a compatibility problem between two third party implementations of
> the TCP checksum.
>
> The problem concerns the representation of zero, which has two 1-s
> complement representations (0000 and ffff).
>
> We don't have source to either stack but I managed to deduce the problem
> from looking at a packet trace.  The receiver drops all datagrams
containing
> a TCP with a TCP checksum of ffff.
>
> The receiver appears to be following the checksum procedure in the RFC
> literally - ie zero checksum, recalculate and check that the result is the
> complement of what the sender sent.  The problem is that the sender and
> receiver don't agree about zero and hence the datagram is dropped
silently.
>
> My view is that the receiver is in error; it should be checking the
special
> case of 0.
>
> All the receiver code I have seen doesn't work this way.  The normal
> approach is to calculate the1-s complement sum with checksum in place and
> check that this is zero.  The methods I konw always return just one
> representation for zero, hence there is no special case.
>
> Any thoughts?
>
> Thanks,
> Chris
>

stupid autoappended signatures below.

----------------------------------------------------------------------------
-------------------------------------
> The information contained in this message is confidential and is intended
> for the addressee(s) only.  If you have received this message in error or
> there are any problems please notify the originator immediately.  The
> unauthorized use, disclosure, copying or alteration of this message is
> strictly forbidden. Baltimore Technologies plc will not be liable for
direct,
> special, indirect or consequential damages arising from alteration of the
> contents of this message by a third party or as a result of any virus
being
> passed on.
>
> In addition, certain Marketing collateral may be added from time to time
to
> promote Baltimore Technologies products, services, Global e-Security or
> appearance at trade shows and conferences.
>
> This footnote confirms that this email message has been swept by
> Baltimore MIMEsweeper for Content Security threats, including
> computer viruses.
>
>

<[email-masked]>PGP<http://www.ee.surrey.ac.uk/Personal/L.Wood/>

-
This message was passed through [email-masked], which
is a sublist of [email-masked]. Not all messages are passed.
Decisions on what to pass are made solely by Raffaele D'Albenzio.

---

From: Lloyd Wood <[email-masked]>
Date: Fri, 5 Apr 2002 21:40:08 +0100 (BST)

> I know there hasn't been much activity on tcp-impl, but it's still there.

...as evidenced by Elsevier Computer Networks magazine and other spam.

> related

I imagine that the egroups thing was subscribed to the real list,
and that this eventually broke after yahoo took over egroups. [egroups
address snipped from cc.]

L.

> but I posted your mail (below) to both, I hope you don't mind.